(in-package :odcl)

;; persistent alists are a poor candidate for transaction + ec
;; behavior: look to the tests in wcof-tests/test-transaction for
;; substantive examples.

(defregression (:transaction 1 4297)
    "create a context, add a rollback that is busted, and then see if transaction is reset"
  (let ((ec (make-instance 'editing-context)))
    (unwind-protect
         (handler-case 
             (with-context (ec)
               (ec-on-txn-abort #'(lambda () (error "I should be thrown")))
               (error "thrown to trip rollback trigger"))
           (ec-rollback-error ()
             t)
           (error (e)
             (error e)))
      (with-context (ec)
            t))))
